2f15762da556fda341f772cd6fe537e2449a2fc3
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
268     # Variables set:
269     # - PYBOT_ARGS - String holding part of all arguments for pybot.
270     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
271
272     set -exuo pipefail
273
274     # No explicit check needed with "set -u".
275     PYBOT_ARGS=("--loglevel" "TRACE")
276     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
277
278     case "${TEST_CODE}" in
279         *"device"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
281             ;;
282         *"perf"*)
283             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
284             ;;
285         *)
286             die "Unknown specification: ${TEST_CODE}"
287     esac
288
289     EXPANDED_TAGS=()
290     for tag in "${TAGS[@]}"; do
291         if [[ ${tag} == "!"* ]]; then
292             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
293         else
294             if [[ ${SELECTION_MODE} == "--test" ]]; then
295                 EXPANDED_TAGS+=("--test" "${tag}")
296             else
297                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
298             fi
299         fi
300     done
301
302     if [[ ${SELECTION_MODE} == "--test" ]]; then
303         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
304     fi
305 }
306
307
308 function deactivate_docker_topology () {
309
310     # Deactivate virtual vpp-device topology by removing containers.
311     #
312     # Variables read:
313     # - NODENESS - Node multiplicity of desired testbed.
314     # - FLAVOR - Node flavor string, usually describing the processor.
315
316     set -exuo pipefail
317
318     case_text="${NODENESS}_${FLAVOR}"
319     case "${case_text}" in
320         "1n_skx" | "1n_tx2")
321             ssh="ssh root@172.17.0.1 -p 6022"
322             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
323             # The "declare -f" output is long and boring.
324             set +x
325             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
326                 die "Topology cleanup via shim-dcr failed!"
327             }
328             set -x
329             ;;
330         "1n_vbox")
331             enter_mutex || die
332             clean_environment || {
333                 die "Topology cleanup locally failed!"
334             }
335             exit_mutex || die
336             ;;
337         *)
338             die "Unknown specification: ${case_text}!"
339     esac
340 }
341
342
343 function die () {
344
345     # Print the message to standard error end exit with error code specified
346     # by the second argument.
347     #
348     # Hardcoded values:
349     # - The default error message.
350     # Arguments:
351     # - ${1} - The whole error message, be sure to quote. Optional
352     # - ${2} - the code to exit with, default: 1.
353
354     set -x
355     set +eu
356     warn "${1:-Unspecified run-time error occurred!}"
357     exit "${2:-1}"
358 }
359
360
361 function die_on_pybot_error () {
362
363     # Source this fragment if you want to abort on any failed test case.
364     #
365     # Variables read:
366     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
367     # Functions called:
368     # - die - Print to stderr and exit.
369
370     set -exuo pipefail
371
372     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
373         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
374     fi
375 }
376
377
378 function generate_tests () {
379
380     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
381     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
382     # The generation is done by executing any *.py executable
383     # within any subdirectory after copying.
384
385     # This is a separate function, because this code is called
386     # both by autogen checker and entries calling run_pybot.
387
388     # Directories read:
389     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
390     # Directories replaced:
391     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
392
393     set -exuo pipefail
394
395     rm -rf "${GENERATED_DIR}/tests" || die
396     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
397     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
398     cmd_line+=("-executable" "-name" "*.py")
399     # We sort the directories, so log output can be compared between runs.
400     file_list=$("${cmd_line[@]}" | sort) || die
401
402     for gen in ${file_list}; do
403         directory="$(dirname "${gen}")" || die
404         filename="$(basename "${gen}")" || die
405         pushd "${directory}" || die
406         ./"${filename}" || die
407         popd || die
408     done
409 }
410
411
412 function get_test_code () {
413
414     # Arguments:
415     # - ${1} - Optional, argument of entry script (or empty as unset).
416     #   Test code value to override job name from environment.
417     # Variables read:
418     # - JOB_NAME - String affecting test selection, default if not argument.
419     # Variables set:
420     # - TEST_CODE - The test selection string from environment or argument.
421     # - NODENESS - Node multiplicity of desired testbed.
422     # - FLAVOR - Node flavor string, usually describing the processor.
423
424     set -exuo pipefail
425
426     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
427     if [[ -z "${TEST_CODE}" ]]; then
428         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
429     fi
430
431     case "${TEST_CODE}" in
432         *"1n-vbox"*)
433             NODENESS="1n"
434             FLAVOR="vbox"
435             ;;
436         *"1n-skx"*)
437             NODENESS="1n"
438             FLAVOR="skx"
439             ;;
440        *"1n-tx2"*)
441             NODENESS="1n"
442             FLAVOR="tx2"
443             ;;
444         *"2n-skx"*)
445             NODENESS="2n"
446             FLAVOR="skx"
447             ;;
448         *"2n-zn2"*)
449             NODENESS="2n"
450             FLAVOR="zn2"
451             ;;
452         *"3n-skx"*)
453             NODENESS="3n"
454             FLAVOR="skx"
455             ;;
456         *"2n-clx"*)
457             NODENESS="2n"
458             FLAVOR="clx"
459             ;;
460         *"2n-dnv"*)
461             NODENESS="2n"
462             FLAVOR="dnv"
463             ;;
464         *"3n-dnv"*)
465             NODENESS="3n"
466             FLAVOR="dnv"
467             ;;
468         *"3n-tsh"*)
469             NODENESS="3n"
470             FLAVOR="tsh"
471             ;;
472         *)
473             # Fallback to 3-node Haswell by default (backward compatibility)
474             NODENESS="3n"
475             FLAVOR="hsw"
476             ;;
477     esac
478 }
479
480
481 function get_test_tag_string () {
482
483     # Variables read:
484     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
485     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
486     # - TEST_CODE - The test selection string from environment or argument.
487     # Variables set:
488     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
489     #   May be empty, or even not set on event types not adding comment.
490
491     # TODO: ci-management scripts no longer need to perform this.
492
493     set -exuo pipefail
494
495     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
496         case "${TEST_CODE}" in
497             *"device"*)
498                 trigger="devicetest"
499                 ;;
500             *"perf"*)
501                 trigger="perftest"
502                 ;;
503             *)
504                 die "Unknown specification: ${TEST_CODE}"
505         esac
506         # Ignore lines not containing the trigger word.
507         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
508         # The vpp-csit triggers trail stuff we are not interested in.
509         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
510         # (except relying on \s whitespace, \S non-whitespace and . both).
511         # The last string is concatenated, only the middle part is expanded.
512         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
513         # On parsing error, TEST_TAG_STRING probably stays empty.
514         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
515         if [[ -z "${TEST_TAG_STRING-}" ]]; then
516             # Probably we got a base64 encoded comment.
517             comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
518             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
519             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
520         fi
521         if [[ -n "${TEST_TAG_STRING-}" ]]; then
522             test_tag_array=(${TEST_TAG_STRING})
523             if [[ "${test_tag_array[0]}" == "icl" ]]; then
524                 export GRAPH_NODE_VARIANT="icl"
525                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
526             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
527                 export GRAPH_NODE_VARIANT="skx"
528                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
529             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
530                 export GRAPH_NODE_VARIANT="hsw"
531                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
532             fi
533         fi
534     fi
535 }
536
537
538 function installed () {
539
540     # Check if the given utility is installed. Fail if not installed.
541     #
542     # Duplicate of common.sh function, as this file is also used standalone.
543     #
544     # Arguments:
545     # - ${1} - Utility to check.
546     # Returns:
547     # - 0 - If command is installed.
548     # - 1 - If command is not installed.
549
550     set -exuo pipefail
551
552     command -v "${1}"
553 }
554
555
556 function move_archives () {
557
558     # Move archive directory to top of workspace, if not already there.
559     #
560     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
561     # but in some jobs CSIT_DIR is not same as WORKSPACE
562     # (e.g. under VPP_DIR). To simplify ci-management settings,
563     # we want to move the data to the top. We do not want simple copy,
564     # as ci-management is eager with recursive search.
565     #
566     # As some scripts may call this function multiple times,
567     # the actual implementation use copying and deletion,
568     # so the workspace gets "union" of contents (except overwrites on conflict).
569     # The consequence is empty ARCHIVE_DIR remaining after this call.
570     #
571     # As the source directory is emptied,
572     # the check for dirs being different is essential.
573     #
574     # Variables read:
575     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
576     #   Can be unset, then it speeds up manual testing.
577     # - ARCHIVE_DIR - Path to directory with content to be moved.
578     # Directories updated:
579     # - ${WORKSPACE}/archives/ - Created if does not exist.
580     #   Content of ${ARCHIVE_DIR}/ is moved.
581     # Functions called:
582     # - die - Print to stderr and exit.
583
584     set -exuo pipefail
585
586     if [[ -n "${WORKSPACE-}" ]]; then
587         target=$(readlink -f "${WORKSPACE}/archives")
588         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
589             mkdir -p "${target}" || die "Archives dir create failed."
590             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
591             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
592         fi
593     fi
594 }
595
596
597 function reserve_and_cleanup_testbed () {
598
599     # Reserve physical testbed, perform cleanup, register trap to unreserve.
600     # When cleanup fails, remove from topologies and keep retrying
601     # until all topologies are removed.
602     #
603     # Variables read:
604     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
605     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
606     # - BUILD_TAG - Any string suitable as filename, identifying
607     #   test run executing this function. May be unset.
608     # Variables set:
609     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
610     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
611     # Functions called:
612     # - die - Print to stderr and exit.
613     # - ansible_playbook - Perform an action using ansible, see ansible.sh
614     # Traps registered:
615     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
616
617     set -exuo pipefail
618
619     while true; do
620         for topo in "${TOPOLOGIES[@]}"; do
621             set +e
622             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
623             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
624             python3 "${scrpt}" "${opts[@]}"
625             result="$?"
626             set -e
627             if [[ "${result}" == "0" ]]; then
628                 # Trap unreservation before cleanup check,
629                 # so multiple jobs showing failed cleanup improve chances
630                 # of humans to notice and fix.
631                 WORKING_TOPOLOGY="${topo}"
632                 echo "Reserved: ${WORKING_TOPOLOGY}"
633                 trap "untrap_and_unreserve_testbed" EXIT || {
634                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
635                     untrap_and_unreserve_testbed "${message}" || {
636                         die "Teardown should have died, not failed."
637                     }
638                     die "Trap attempt failed, unreserve succeeded. Aborting."
639                 }
640                 # Cleanup + calibration checks.
641                 set +e
642                 ansible_playbook "cleanup, calibration"
643                 result="$?"
644                 set -e
645                 if [[ "${result}" == "0" ]]; then
646                     break
647                 fi
648                 warn "Testbed cleanup failed: ${topo}"
649                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
650             fi
651             # Else testbed is accessible but currently reserved, moving on.
652         done
653
654         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
655             # Exit the infinite while loop if we made a reservation.
656             warn "Reservation and cleanup successful."
657             break
658         fi
659
660         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
661             die "Run out of operational testbeds!"
662         fi
663
664         # Wait ~3minutes before next try.
665         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
666             die "Sleep time calculation failed."
667         }
668         echo "Sleeping ${sleep_time}"
669         sleep "${sleep_time}" || die "Sleep failed."
670     done
671 }
672
673
674 function run_pybot () {
675
676     # Run pybot with options based on input variables. Create output_info.xml
677     #
678     # Variables read:
679     # - CSIT_DIR - Path to existing root of local CSIT git repository.
680     # - ARCHIVE_DIR - Path to store robot result files in.
681     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
682     # - GENERATED_DIR - Tests are assumed to be generated under there.
683     # Variables set:
684     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
685     # Functions called:
686     # - die - Print to stderr and exit.
687
688     set -exuo pipefail
689
690     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
691     all_options+=("--noncritical" "EXPECTED_FAILING")
692     all_options+=("${EXPANDED_TAGS[@]}")
693
694     pushd "${CSIT_DIR}" || die "Change directory operation failed."
695     set +e
696     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
697     PYBOT_EXIT_STATUS="$?"
698     set -e
699
700     # Generate INFO level output_info.xml for post-processing.
701     all_options=("--loglevel" "INFO")
702     all_options+=("--log" "none")
703     all_options+=("--report" "none")
704     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
705     all_options+=("${ARCHIVE_DIR}/output.xml")
706     rebot "${all_options[@]}" || true
707     popd || die "Change directory operation failed."
708 }
709
710
711 function select_arch_os () {
712
713     # Set variables affected by local CPU architecture and operating system.
714     #
715     # Variables set:
716     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
717     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
718     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
719
720     set -exuo pipefail
721
722     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
723         die "Get OS release failed."
724     }
725
726     case "${os_id}" in
727         "ubuntu"*)
728             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
729             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
730             PKG_SUFFIX="deb"
731             ;;
732         "centos"*)
733             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
734             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
735             PKG_SUFFIX="rpm"
736             ;;
737         *)
738             die "Unable to identify distro or os from ${os_id}"
739             ;;
740     esac
741
742     arch=$(uname -m) || {
743         die "Get CPU architecture failed."
744     }
745
746     case "${arch}" in
747         "aarch64")
748             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
749             ;;
750         *)
751             ;;
752     esac
753 }
754
755
756 function select_tags () {
757
758     # Variables read:
759     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
760     # - TEST_CODE - String affecting test selection, usually jenkins job name.
761     # - DUT - CSIT test/ subdirectory, set while processing tags.
762     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
763     #   Can be unset.
764     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
765     # - BASH_FUNCTION_DIR - Directory with input files to process.
766     # Variables set:
767     # - TAGS - Array of processed tag boolean expressions.
768     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
769
770     set -exuo pipefail
771
772     # NIC SELECTION
773     start_pattern='^  TG:'
774     end_pattern='^ \? \?[A-Za-z0-9]\+:'
775     # Remove the TG section from topology file
776     sed_command="/${start_pattern}/,/${end_pattern}/d"
777     # All topologies DUT NICs
778     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
779                 | grep -hoP "model: \K.*" | sort -u)
780     # Selected topology DUT NICs
781     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
782                | grep -hoP "model: \K.*" | sort -u)
783     # All topologies DUT NICs - Selected topology DUT NICs
784     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
785         die "Computation of excluded NICs failed."
786     }
787
788     # Select default NIC tag.
789     case "${TEST_CODE}" in
790         *"3n-dnv"* | *"2n-dnv"*)
791             default_nic="nic_intel-x553"
792             ;;
793         *"3n-tsh"*)
794             default_nic="nic_intel-x520-da2"
795             ;;
796         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
797             default_nic="nic_intel-xxv710"
798             ;;
799         *"3n-hsw"* | *"mrr-daily-master")
800             default_nic="nic_intel-xl710"
801             ;;
802         *)
803             default_nic="nic_intel-x710"
804             ;;
805     esac
806
807     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
808     awk_nics_sub_cmd=""
809     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
810     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
811     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
812     awk_nics_sub_cmd+='gsub("x520","10ge2p1x520");'
813     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
814     awk_nics_sub_cmd+='gsub("cx556a","10ge2p1cx556a");'
815     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
816     awk_nics_sub_cmd+='gsub("vic1385","10ge2p1vic1385");'
817     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
818     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
819     awk_nics_sub_cmd+='else drv="";'
820     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
821
822     # Tag file directory shorthand.
823     tfd="${JOB_SPECS_DIR}"
824     case "${TEST_CODE}" in
825         # Select specific performance tests based on jenkins job type variable.
826         *"ndrpdr-weekly"* )
827             readarray -t test_tag_array <<< $(grep -v "#" \
828                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
829                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
830             SELECTION_MODE="--test"
831             ;;
832         *"mrr-daily"* )
833             readarray -t test_tag_array <<< $(grep -v "#" \
834                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
835                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
836             SELECTION_MODE="--test"
837             ;;
838         *"mrr-weekly"* )
839             readarray -t test_tag_array <<< $(grep -v "#" \
840                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
841                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
842             SELECTION_MODE="--test"
843             ;;
844         *"report-iterative"* )
845             test_sets=(${TEST_TAG_STRING//:/ })
846             # Run only one test set per run
847             report_file=${test_sets[0]}.md
848             readarray -t test_tag_array <<< $(grep -v "#" \
849                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
850                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
851             SELECTION_MODE="--test"
852             ;;
853         *"report-coverage"* )
854             test_sets=(${TEST_TAG_STRING//:/ })
855             # Run only one test set per run
856             report_file=${test_sets[0]}.md
857             readarray -t test_tag_array <<< $(grep -v "#" \
858                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
859                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
860             SELECTION_MODE="--test"
861             ;;
862         * )
863             if [[ -z "${TEST_TAG_STRING-}" ]]; then
864                 # If nothing is specified, we will run pre-selected tests by
865                 # following tags.
866                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
867                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
868                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
869                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
870                                 "!dot1q" "!drv_avf")
871             else
872                 # If trigger contains tags, split them into array.
873                 test_tag_array=(${TEST_TAG_STRING//:/ })
874             fi
875             SELECTION_MODE="--include"
876             ;;
877     esac
878
879     # Blacklisting certain tags per topology.
880     #
881     # Reasons for blacklisting:
882     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
883     # TODO: Add missing reasons here (if general) or where used (if specific).
884     case "${TEST_CODE}" in
885         *"2n-skx"*)
886             test_tag_array+=("!ipsec")
887             ;;
888         *"3n-skx"*)
889             test_tag_array+=("!ipsechw")
890             # Not enough nic_intel-xxv710 to support double link tests.
891             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
892             ;;
893         *"2n-clx"*)
894             test_tag_array+=("!ipsec")
895             ;;
896         *"2n-zn2"*)
897             test_tag_array+=("!ipsec")
898             ;;
899         *"2n-dnv"*)
900             test_tag_array+=("!ipsechw")
901             test_tag_array+=("!memif")
902             test_tag_array+=("!srv6_proxy")
903             test_tag_array+=("!vhost")
904             test_tag_array+=("!vts")
905             test_tag_array+=("!drv_avf")
906             ;;
907         *"3n-dnv"*)
908             test_tag_array+=("!memif")
909             test_tag_array+=("!srv6_proxy")
910             test_tag_array+=("!vhost")
911             test_tag_array+=("!vts")
912             test_tag_array+=("!drv_avf")
913             ;;
914         *"3n-tsh"*)
915             # 3n-tsh only has x520 NICs which don't work with AVF
916             test_tag_array+=("!drv_avf")
917             test_tag_array+=("!ipsechw")
918             ;;
919         *"3n-hsw"*)
920             test_tag_array+=("!drv_avf")
921             # All cards have access to QAT. But only one card (xl710)
922             # resides in same NUMA as QAT. Other cards must go over QPI
923             # which we do not want to even run.
924             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
925             ;;
926         *)
927             # Default to 3n-hsw due to compatibility.
928             test_tag_array+=("!drv_avf")
929             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
930             ;;
931     esac
932
933     # We will add excluded NICs.
934     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
935
936     TAGS=()
937     prefix=""
938
939     set +x
940     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
941         # Automatic prefixing for VPP jobs to limit the NIC used and
942         # traffic evaluation to MRR.
943         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
944             prefix="${prefix}mrrAND"
945         else
946             prefix="${prefix}mrrAND${default_nic}AND"
947         fi
948     fi
949     for tag in "${test_tag_array[@]}"; do
950         if [[ "${tag}" == "!"* ]]; then
951             # Exclude tags are not prefixed.
952             TAGS+=("${tag}")
953         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
954             # Badly formed tag expressions can trigger way too much tests.
955             set -x
956             warn "The following tag expression hints at bad trigger: ${tag}"
957             warn "Possible cause: Multiple triggers in a single comment."
958             die "Aborting to avoid triggering too many tests."
959         elif [[ "${tag}" == *"OR"* ]]; then
960             # If OR had higher precedence than AND, it would be useful here.
961             # Some people think it does, thus triggering way too much tests.
962             set -x
963             warn "The following tag expression hints at bad trigger: ${tag}"
964             warn "Operator OR has lower precedence than AND. Use space instead."
965             die "Aborting to avoid triggering too many tests."
966         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
967             # Empty and comment lines are skipped.
968             # Other lines are normal tags, they are to be prefixed.
969             TAGS+=("${prefix}${tag}")
970         fi
971     done
972     set -x
973 }
974
975
976 function select_topology () {
977
978     # Variables read:
979     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
980     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
981     # - CSIT_DIR - Path to existing root of local CSIT git repository.
982     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
983     # Variables set:
984     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
985     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
986     # Functions called:
987     # - die - Print to stderr and exit.
988
989     set -exuo pipefail
990
991     case_text="${NODENESS}_${FLAVOR}"
992     case "${case_text}" in
993         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
994         # TODO: Double link availability depends on NIC used.
995         "1n_vbox")
996             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
997             TOPOLOGIES_TAGS="2_node_single_link_topo"
998             ;;
999         "1n_skx" | "1n_tx2")
1000             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1001             TOPOLOGIES_TAGS="2_node_single_link_topo"
1002             ;;
1003         "2n_skx")
1004             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1005             TOPOLOGIES_TAGS="2_node_*_link_topo"
1006             ;;
1007         "2n_zn2")
1008             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1009             TOPOLOGIES_TAGS="2_node_*_link_topo"
1010             ;;
1011         "3n_skx")
1012             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1013             TOPOLOGIES_TAGS="3_node_*_link_topo"
1014             ;;
1015         "2n_clx")
1016             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1017             TOPOLOGIES_TAGS="2_node_*_link_topo"
1018             ;;
1019         "2n_dnv")
1020             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1021             TOPOLOGIES_TAGS="2_node_single_link_topo"
1022             ;;
1023         "3n_dnv")
1024             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1025             TOPOLOGIES_TAGS="3_node_single_link_topo"
1026             ;;
1027         "3n_hsw")
1028             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
1029             TOPOLOGIES_TAGS="3_node_single_link_topo"
1030             ;;
1031         "3n_tsh")
1032             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1033             TOPOLOGIES_TAGS="3_node_single_link_topo"
1034             ;;
1035         *)
1036             # No falling back to 3n_hsw default, that should have been done
1037             # by the function which has set NODENESS and FLAVOR.
1038             die "Unknown specification: ${case_text}"
1039     esac
1040
1041     if [[ -z "${TOPOLOGIES-}" ]]; then
1042         die "No applicable topology found!"
1043     fi
1044 }
1045
1046
1047 function select_vpp_device_tags () {
1048
1049     # Variables read:
1050     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1051     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1052     #   Can be unset.
1053     # Variables set:
1054     # - TAGS - Array of processed tag boolean expressions.
1055
1056     set -exuo pipefail
1057
1058     case "${TEST_CODE}" in
1059         # Select specific device tests based on jenkins job type variable.
1060         * )
1061             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1062                 # If nothing is specified, we will run pre-selected tests by
1063                 # following tags. Items of array will be concatenated by OR
1064                 # in Robot Framework.
1065                 test_tag_array=()
1066             else
1067                 # If trigger contains tags, split them into array.
1068                 test_tag_array=(${TEST_TAG_STRING//:/ })
1069             fi
1070             SELECTION_MODE="--include"
1071             ;;
1072     esac
1073
1074     # Blacklisting certain tags per topology.
1075     #
1076     # Reasons for blacklisting:
1077     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1078     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1079     case "${TEST_CODE}" in
1080         *"1n-vbox"*)
1081             test_tag_array+=("!avf")
1082             test_tag_array+=("!vhost")
1083             ;;
1084         *)
1085             ;;
1086     esac
1087
1088     TAGS=()
1089
1090     # We will prefix with devicetest to prevent running other tests
1091     # (e.g. Functional).
1092     prefix="devicetestAND"
1093     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1094         # Automatic prefixing for VPP jobs to limit testing.
1095         prefix="${prefix}"
1096     fi
1097     for tag in "${test_tag_array[@]}"; do
1098         if [[ ${tag} == "!"* ]]; then
1099             # Exclude tags are not prefixed.
1100             TAGS+=("${tag}")
1101         else
1102             TAGS+=("${prefix}${tag}")
1103         fi
1104     done
1105 }
1106
1107 function untrap_and_unreserve_testbed () {
1108
1109     # Use this as a trap function to ensure testbed does not remain reserved.
1110     # Perhaps call directly before script exit, to free testbed for other jobs.
1111     # This function is smart enough to avoid multiple unreservations (so safe).
1112     # Topo cleanup is executed (call it best practice), ignoring failures.
1113     #
1114     # Hardcoded values:
1115     # - default message to die with if testbed might remain reserved.
1116     # Arguments:
1117     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1118     # Variables read (by inner function):
1119     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1120     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1121     # Variables written:
1122     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1123     # Trap unregistered:
1124     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1125     # Functions called:
1126     # - die - Print to stderr and exit.
1127     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1128
1129     set -xo pipefail
1130     set +eu  # We do not want to exit early in a "teardown" function.
1131     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1132     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1133     if [[ -z "${wt-}" ]]; then
1134         set -eu
1135         warn "Testbed looks unreserved already. Trap removal failed before?"
1136     else
1137         ansible_playbook "cleanup" || true
1138         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1139             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1140         }
1141         WORKING_TOPOLOGY=""
1142         set -eu
1143     fi
1144 }
1145
1146
1147 function warn () {
1148
1149     # Print the message to standard error.
1150     #
1151     # Arguments:
1152     # - ${@} - The text of the message.
1153
1154     set -exuo pipefail
1155
1156     echo "$@" >&2
1157 }